r24339: Move output functions to separate files.
[kai/samba.git] / source4 / selftest / Samba4.pm
1 #!/usr/bin/perl
2 # Bootstrap Samba and run a number of tests against it.
3 # Copyright (C) 2005-2007 Jelmer Vernooij <jelmer@samba.org>
4 # Published under the GNU GPL, v3 or later.
5
6 package Samba4;
7
8 use strict;
9 use Cwd qw(abs_path);
10 use FindBin qw($RealBin);
11 use POSIX;
12
13 sub new($$$$) {
14         my ($classname, $bindir, $ldap, $setupdir) = @_;
15         my $self = { 
16                 vars => {}, 
17                 ldap => $ldap, 
18                 bindir => $bindir, 
19                 setupdir => $setupdir 
20         };
21         bless $self;
22         return $self;
23 }
24
25 sub openldap_start($$$) {
26         my ($slapd_conf, $uri, $logs) = @_;
27         my $oldpath = $ENV{PATH};
28         $ENV{PATH} = "/usr/local/sbin:/usr/sbin:/sbin:$ENV{PATH}";
29         system("slapd -d0 -f $slapd_conf -h $uri > $logs 2>&1 &");
30         $ENV{PATH} = $oldpath;
31 }
32
33 sub slapd_start($$)
34 {
35         my $count = 0;
36         my ($self, $env_vars) = @_;
37
38         my $uri = $env_vars->{LDAP_URI};
39
40         # running slapd in the background means it stays in the same process group, so it can be
41         # killed by timelimit
42         if ($self->{ldap} eq "fedora-ds") {
43                 system("$ENV{FEDORA_DS_PREFIX}/sbin/ns-slapd -D $env_vars->{FEDORA_DS_DIR} -d0 -i $env_vars->{FEDORA_DS_PIDFILE}> $env_vars->{LDAPDIR}/logs 2>&1 &");
44         } elsif ($self->{ldap} eq "openldap") {
45                 openldap_start($env_vars->{SLAPD_CONF}, $uri, "$env_vars->{LDAPDIR}/logs");
46         }
47         while (system("$self->{bindir}/ldbsearch -H $uri -s base -b \"\" supportedLDAPVersion > /dev/null") != 0) {
48                 $count++;
49                 if ($count > 40) {
50                     $self->slapd_stop($env_vars);
51                     return 0;
52                 }
53                 sleep(1);
54         }
55         return 1;
56 }
57
58 sub slapd_stop($$)
59 {
60         my ($self, $envvars) = @_;
61         if ($self->{ldap} eq "fedora-ds") {
62                 system("$envvars->{LDAPDIR}/slapd-samba4/stop-slapd");
63         } elsif ($self->{ldap} eq "openldap") {
64                 open(IN, "<$envvars->{OPENLDAP_PIDFILE}") or 
65                         die("unable to open slapd pid file: $envvars->{OPENLDAP_PIDFILE}");
66                 kill 9, <IN>;
67                 close(IN);
68         }
69         return 1;
70 }
71
72 sub check_or_start($$$) 
73 {
74         my ($self, $env_vars, $max_time) = @_;
75         return 0 if ( -p $env_vars->{SMBD_TEST_FIFO});
76
77         unlink($env_vars->{SMBD_TEST_FIFO});
78         POSIX::mkfifo($env_vars->{SMBD_TEST_FIFO}, 0700);
79         unlink($env_vars->{SMBD_TEST_LOG});
80         
81         print "STARTING SMBD... ";
82         my $pid = fork();
83         if ($pid == 0) {
84                 open STDIN, $env_vars->{SMBD_TEST_FIFO};
85                 open STDOUT, ">$env_vars->{SMBD_TEST_LOG}";
86                 open STDERR, '>&STDOUT';
87                 
88                 SocketWrapper::set_default_iface($env_vars->{SOCKET_WRAPPER_DEFAULT_IFACE});
89
90                 my $valgrind = "";
91                 if (defined($ENV{SMBD_VALGRIND})) {
92                     $valgrind = $ENV{SMBD_VALGRIND};
93                 } 
94
95                 $ENV{KRB5_CONFIG} = $env_vars->{KRB5_CONFIG}; 
96
97                 # Start slapd before smbd, but with the fifo on stdin
98                 if (defined($self->{ldap})) {
99                     $self->slapd_start($env_vars) or 
100                         die("couldn't start slapd (2nd time)");
101                 }
102
103                 my $optarg = "";
104                 if (defined($max_time)) {
105                         $optarg = "--maximum-runtime=$max_time ";
106                 }
107                 my $ret = system("$valgrind $self->{bindir}/smbd $optarg $env_vars->{CONFIGURATION} -M single -i --leak-report-full");
108                 if ($? == -1) {
109                         print "Unable to start smbd: $ret: $!\n";
110                         exit 1;
111                 }
112                 unlink($env_vars->{SMBD_TEST_FIFO});
113                 my $exit = $? >> 8;
114                 if ( $ret == 0 ) {
115                         print "smbd exits with status $exit\n";
116                 } elsif ( $ret & 127 ) {
117                         print "smbd got signal ".($ret & 127)." and exits with $exit!\n";
118                 } else {
119                         $ret = $? >> 8;
120                         print "smbd failed with status $exit!\n";
121                 }
122                 exit $exit;
123         }
124         print "DONE\n";
125
126         open(DATA, ">$env_vars->{SMBD_TEST_FIFO}");
127
128         return $pid;
129 }
130
131 sub wait_for_start($$)
132 {
133         my ($self, $testenv_vars) = @_;
134         # give time for nbt server to register its names
135         print "delaying for nbt name registration\n";
136         sleep 2;
137
138         # This will return quickly when things are up, but be slow if we 
139         # need to wait for (eg) SSL init 
140         system("bin/nmblookup $testenv_vars->{CONFIGURATION} $testenv_vars->{SERVER}");
141         system("bin/nmblookup $testenv_vars->{CONFIGURATION} -U $testenv_vars->{SERVER_IP} $testenv_vars->{SERVER}");
142         system("bin/nmblookup $testenv_vars->{CONFIGURATION} $testenv_vars->{NETBIOSNAME}");
143         system("bin/nmblookup $testenv_vars->{CONFIGURATION} -U $testenv_vars->{SERVER_IP} $testenv_vars->{NETBIOSNAME}");
144         system("bin/nmblookup $testenv_vars->{CONFIGURATION} $testenv_vars->{NETBIOSALIAS}");
145         system("bin/nmblookup $testenv_vars->{CONFIGURATION} -U $testenv_vars->{SERVER_IP} $testenv_vars->{NETBIOSALIAS}");
146         system("bin/nmblookup $testenv_vars->{CONFIGURATION} $testenv_vars->{SERVER}");
147         system("bin/nmblookup $testenv_vars->{CONFIGURATION} -U $testenv_vars->{SERVER_IP} $testenv_vars->{SERVER}");
148         system("bin/nmblookup $testenv_vars->{CONFIGURATION} $testenv_vars->{NETBIOSNAME}");
149         system("bin/nmblookup $testenv_vars->{CONFIGURATION} -U $testenv_vars->{SERVER_IP} $testenv_vars->{NETBIOSNAME}");
150         system("bin/nmblookup $testenv_vars->{CONFIGURATION} $testenv_vars->{NETBIOSALIAS}");
151         system("bin/nmblookup $testenv_vars->{CONFIGURATION} -U $testenv_vars->{SERVER_IP} $testenv_vars->{NETBIOSALIAS}");
152
153         print $self->getlog_env($testenv_vars);
154 }
155
156 sub write_ldb_file($$$)
157 {
158         my ($self, $file, $ldif) = @_;
159
160         open(LDIF, "|$self->{bindir}/ldbadd -H $file >/dev/null");
161         print LDIF $ldif;
162         return close(LDIF);
163 }
164
165 sub add_wins_config($$)
166 {
167         my ($self, $privatedir) = @_;
168
169         return $self->write_ldb_file("$privatedir/wins_config.ldb", "
170 dn: name=TORTURE_6,CN=PARTNERS
171 objectClass: wreplPartner
172 name: TORTURE_6
173 address: 127.0.0.6
174 pullInterval: 0
175 pushChangeCount: 0
176 type: 0x3
177 ");
178 }
179
180 sub mk_fedora_ds($$$)
181 {
182         my ($self, $ldapdir, $configuration) = @_;
183
184         my $fedora_ds_inf = "$ldapdir/fedorads.inf";
185         my $fedora_ds_extra_ldif = "$ldapdir/fedorads-partitions.ldif";
186
187         #Make the subdirectory be as fedora DS would expect
188         my $fedora_ds_dir = "$ldapdir/slapd-samba4";
189
190         my $pidfile = "$fedora_ds_dir/logs/slapd-samba4.pid";
191
192 my $dir = getcwd();
193 chdir "$ENV{FEDORA_DS_PREFIX}/bin" || die;
194         if (system("perl $ENV{FEDORA_DS_PREFIX}/bin/ds_newinst.pl $fedora_ds_inf >&2") != 0) {
195             chdir $dir;
196             die("perl $ENV{FEDORA_DS_PREFIX}/bin/ds_newinst.pl $fedora_ds_inf FAILED: $?");
197         }
198         chdir $dir || die;
199
200         system("cat $fedora_ds_extra_ldif >> $fedora_ds_dir/dse.ldif");
201
202         system("$self->{bindir}/ad2oLschema $configuration -H $ldapdir/schema-tmp.ldb --option=convert:target=fedora-ds -I $self->{setupdir}/schema-map-fedora-ds-1.0 -O $fedora_ds_dir/schema/99_ad.ldif >&2") == 0 or die("schema conversion for Fedora DS failed");
203
204         return ($fedora_ds_dir, $pidfile);
205 }
206
207 sub mk_openldap($$$)
208 {
209         my ($self, $ldapdir, $configuration) = @_;
210
211         my $slapd_conf = "$ldapdir/slapd.conf";
212         my $pidfile = "$ldapdir/slapd.pid";
213         my $modconf = "$ldapdir/modules.conf";
214
215         #This uses the backend provision we just did, to read out the schema
216         system("$self->{bindir}/ad2oLschema $configuration --option=convert:target=openldap -H $ldapdir/schema-tmp.ldb -I $self->{setupdir}/schema-map-openldap-2.3 -O $ldapdir/backend-schema.schema >&2") == 0 or die("schema conversion for OpenLDAP failed");
217
218         my $oldpath = $ENV{PATH};
219         $ENV{PATH} = "/usr/local/sbin:/usr/sbin:/sbin:$ENV{PATH}";
220
221         unlink($modconf);
222         open(CONF, ">$modconf"); close(CONF);
223
224         if (system("slaptest -u -f $slapd_conf >&2") != 0) {
225                 open(CONF, ">$modconf"); 
226                 # enable slapd modules
227                 print CONF "
228 modulepath      /usr/lib/ldap
229 moduleload      back_bdb
230 moduleload      syncprov
231 ";
232                 close(CONF);
233         }
234
235         system("slaptest -u -f $slapd_conf") == 0 or die("slaptest still fails after adding modules");
236
237     
238         $ENV{PATH} = $oldpath;
239
240         return ($slapd_conf, $pidfile);
241 }
242
243 sub provision($$$$$$)
244 {
245         my ($self, $prefix, $server_role, $netbiosname, $netbiosalias, $swiface, $password) = @_;
246
247         my $smbd_loglevel = 1;
248         my $username = "administrator";
249         my $domain = "SAMBADOMAIN";
250         my $realm = "SAMBA.EXAMPLE.COM";
251         my $dnsname = "samba.example.com";
252         my $basedn = "dc=samba,dc=example,dc=com";
253         my $root = ($ENV{USER} or $ENV{LOGNAME} or `whoami`);
254         my $srcdir="$RealBin/..";
255         -d $prefix or mkdir($prefix, 0777) or die("Unable to create $prefix");
256         my $prefix_abs = abs_path($prefix);
257         my $tmpdir = "$prefix_abs/tmp";
258         my $etcdir = "$prefix_abs/etc";
259         my $piddir = "$prefix_abs/pid";
260         my $conffile = "$etcdir/smb.conf";
261         my $krb5_config = "$etcdir/krb5.conf";
262         my $privatedir = "$prefix_abs/private";
263         my $ncalrpcdir = "$prefix_abs/ncalrpc";
264         my $lockdir = "$prefix_abs/lockdir";
265         my $winbindd_socket_dir = "$prefix_abs/winbind_socket";
266
267         my $configuration = "--configfile=$conffile";
268         my $ldapdir = "$privatedir/ldap";
269
270         my $tlsdir = "$privatedir/tls";
271
272         my $ifaceipv4 = "127.0.0.$swiface";
273         my $interfaces = "$ifaceipv4/8";
274
275         (system("rm -rf $prefix/*") == 0) or die("Unable to clean up");
276         mkdir($_, 0777) foreach ($privatedir, $etcdir, $piddir, $ncalrpcdir, $lockdir, 
277                 $tmpdir);
278
279
280         my $localdomain = $domain;
281         $localdomain = $netbiosname if $server_role eq "member server";
282         my $localrealm = $realm;
283         $localrealm = $netbiosname if $server_role eq "member server";
284         my $localbasedn = $basedn;
285         $localbasedn = "DC=$netbiosname" if $server_role eq "member server";
286
287         open(CONFFILE, ">$conffile");
288         print CONFFILE "
289 [global]
290         netbios name = $netbiosname
291         netbios aliases = $netbiosalias
292         workgroup = $domain
293         realm = $realm
294         private dir = $privatedir
295         pid directory = $piddir
296         ncalrpc dir = $ncalrpcdir
297         lock dir = $lockdir
298         setup directory = $self->{setupdir}
299         js include = $srcdir/scripting/libjs
300         winbindd socket directory = $winbindd_socket_dir
301         winbind separator = /
302         name resolve order = bcast
303         interfaces = $interfaces
304         tls dh params file = $tlsdir/dhparms.pem
305         panic action = $srcdir/script/gdb_backtrace \%PID% \%PROG%
306         wins support = yes
307         server role = $server_role
308         max xmit = 32K
309         server max protocol = SMB2
310         notify:inotify = false
311         ldb:nosync = true
312         system:anonymous = true
313 #We don't want to pass our self-tests if the PAC code is wrong
314         gensec:require_pac = true
315         log level = $smbd_loglevel
316
317 [tmp]
318         path = $tmpdir
319         read only = no
320         ntvfs handler = posix
321         posix:sharedelay = 100000
322         posix:eadb = $lockdir/eadb.tdb
323
324 [cifs]
325         read only = no
326         ntvfs handler = cifs
327         cifs:server = $netbiosname
328         cifs:share = tmp
329 #There is no username specified here, instead the client is expected
330 #to log in with kerberos, and smbd will used delegated credentials.
331
332 [simple]
333         path = $tmpdir
334         read only = no
335         ntvfs handler = simple
336
337 [cifsposix]
338         copy = simple
339         ntvfs handler = cifsposix   
340 ";
341         close(CONFFILE);
342
343         die ("Unable to create key blobs") if
344                 (system("TLSDIR=$tlsdir $RealBin/mk-keyblobs.sh") != 0);
345
346         open(KRB5CONF, ">$krb5_config");
347         print KRB5CONF "
348 #Generated krb5.conf for $realm
349
350 [libdefaults]
351  default_realm = $realm
352  dns_lookup_realm = false
353  dns_lookup_kdc = false
354  ticket_lifetime = 24h
355  forwardable = yes
356
357 [realms]
358  $realm = {
359   kdc = 127.0.0.1:88
360   admin_server = 127.0.0.1:88
361   default_domain = $dnsname
362  }
363  $dnsname = {
364   kdc = 127.0.0.1:88
365   admin_server = 127.0.0.1:88
366   default_domain = $dnsname
367  }
368  $domain = {
369   kdc = 127.0.0.1:88
370   admin_server = 127.0.0.1:88
371   default_domain = $dnsname
372  }
373
374 [appdefaults]
375         pkinit_anchors = FILE:$tlsdir/ca.pem
376
377 [kdc]
378         enable-pkinit = true
379         pkinit_identity = FILE:$tlsdir/kdc.pem,$tlsdir/key.pem
380         pkinit_anchors = FILE:$tlsdir/ca.pem
381
382 [domain_realm]
383  .$dnsname = $realm
384 ";
385         close(KRB5CONF);
386
387 #Ensure the config file is valid before we start
388         if (system("$self->{bindir}/testparm $configuration -v --suppress-prompt >/dev/null 2>&1") != 0) {
389                 system("$self->{bindir}/testparm -v --suppress-prompt $configuration >&2");
390                 die("Failed to create a valid smb.conf configuration!");
391         }
392
393         (system("($self->{bindir}/testparm $configuration -v --suppress-prompt --parameter-name=\"netbios name\" --section-name=global 2> /dev/null | grep -i \"^$netbiosname\" ) >/dev/null 2>&1") == 0) or die("Failed to create a valid smb.conf configuration!");
394
395 my @provision_options = ("$self->{bindir}/smbscript", "$self->{setupdir}/provision");
396         push (@provision_options, split(' ', $configuration));
397         push (@provision_options, "--host-name=$netbiosname");
398         push (@provision_options, "--host-ip=$ifaceipv4");
399         push (@provision_options, "--quiet");
400         push (@provision_options, "--domain=$localdomain");
401         push (@provision_options, "--realm=$localrealm");
402         push (@provision_options, "--adminpass=$password");
403         push (@provision_options, "--krbtgtpass=krbtgt$password");
404         push (@provision_options, "--machinepass=machine$password");
405         push (@provision_options, "--root=$root");
406         push (@provision_options, "--simple-bind-dn=cn=Manager,$localbasedn");
407         push (@provision_options, "--password=$password");
408         push (@provision_options, "--root=$root");
409
410         my $ldap_uri= "$ldapdir/ldapi";
411         $ldap_uri =~ s|/|%2F|g;
412         $ldap_uri = "ldapi://$ldap_uri";
413
414         my $ret = {
415                 KRB5_CONFIG => $krb5_config,
416                 PIDDIR => $piddir,
417                 SERVER => $netbiosname,
418                 SERVER_IP => $ifaceipv4,
419                 NETBIOSNAME => $netbiosname,
420                 NETBIOSALIAS => $netbiosalias,
421                 LDAP_URI => $ldap_uri,
422                 DOMAIN => $domain,
423                 USERNAME => $username,
424                 REALM => $realm,
425                 PASSWORD => $password,
426                 LDAPDIR => $ldapdir,
427                 WINBINDD_SOCKET_DIR => $winbindd_socket_dir,
428                 NCALRPCDIR => $ncalrpcdir,
429                 CONFIGURATION => $configuration,
430                 SOCKET_WRAPPER_DEFAULT_IFACE => $swiface
431         };
432
433         if (defined($self->{ldap})) {
434
435                 push (@provision_options, "--ldap-backend=$ldap_uri");
436                 system("$self->{bindir}/smbscript $self->{setupdir}/provision-backend $configuration --ldap-manager-pass=$password --root=$root --realm=$localrealm --host-name=$netbiosname --ldap-backend-type=$self->{ldap}>&2") == 0 or die("backend provision failed");
437
438                 if ($self->{ldap} eq "openldap") {
439                        ($ret->{SLAPD_CONF}, $ret->{OPENLDAP_PIDFILE}) = $self->mk_openldap($ldapdir, $configuration) or die("Unable to create openldap directories");
440                 } elsif ($self->{ldap} eq "fedora-ds") {
441                        ($ret->{FEDORA_DS_DIR}, $ret->{FEDORA_DS_PIDFILE}) = $self->mk_fedora_ds($ldapdir, $configuration) or die("Unable to create fedora ds directories");
442                        push (@provision_options, "--ldap-module=nsuniqueid");
443                        push (@provision_options, "--aci=aci:: KHRhcmdldGF0dHIgPSAiKiIpICh2ZXJzaW9uIDMuMDthY2wgImZ1bGwgYWNjZXNzIHRvIGFsbCBieSBhbGwiO2FsbG93IChhbGwpKHVzZXJkbiA9ICJsZGFwOi8vL2FueW9uZSIpOykK");
444                  }
445
446                 $self->slapd_start($ret) or 
447                         die("couldn't start slapd");
448         }
449
450         (system(@provision_options) == 0) or die("Unable to provision");
451
452         if (defined($self->{ldap})) {
453                 $self->slapd_stop($ret) or 
454                         die("couldn't stop slapd");
455         }
456
457         return $ret; 
458 }
459
460 sub provision_member($$$)
461 {
462         my ($self, $prefix, $dcvars) = @_;
463         print "PROVISIONING MEMBER...";
464
465         my $ret = $self->provision($prefix,
466                                    "member server",
467                                    "localmember3",
468                                    "localmember",
469                                    3,
470                                    "localmemberpass");
471
472         $ret or die("Unable to provision");
473
474         my $cmd = "";
475         $cmd .= "SOCKET_WRAPPER_DEFAULT_IFACE=\"$ret->{SOCKET_WRAPPER_DEFAULT_IFACE}\" ";
476         $cmd .= "KRB5_CONFIG=\"$ret->{KRB5_CONFIG}\" ";
477         $cmd .= "$self->{bindir}/net join $ret->{CONFIGURATION} $dcvars->{DOMAIN} member";
478         $cmd .= " -U$dcvars->{USERNAME}\%$dcvars->{PASSWORD}";
479
480         system($cmd) == 0 or die("Join failed\n$cmd");
481
482         $ret->{SMBD_TEST_FIFO} = "$prefix/smbd_test.fifo";
483         $ret->{SMBD_TEST_LOG} = "$prefix/smbd_test.log";
484         $ret->{SMBD_TEST_LOG_POS} = 0;
485
486         $ret->{DC_SERVER} = $dcvars->{SERVER};
487         $ret->{DC_SERVER_IP} = $dcvars->{SERVER_IP};
488         $ret->{DC_NETBIOSNAME} = $dcvars->{NETBIOSNAME};
489         $ret->{DC_NETBIOSALIAS} = $dcvars->{NETBIOSALIAS};
490         $ret->{DC_USERNAME} = $dcvars->{USERNAME};
491         $ret->{DC_PASSWORD} = $dcvars->{PASSWORD};
492
493         return $ret;
494 }
495
496 sub provision_dc($$)
497 {
498         my ($self, $prefix) = @_;
499
500         print "PROVISIONING DC...";
501         my $ret = $self->provision($prefix,
502                                    "domain controller",
503                                    "localdc1",
504                                    "localdc",
505                                    1,
506                                    "localdcpass");
507
508         $self->add_wins_config("$prefix/private") or 
509                 die("Unable to add wins configuration");
510
511         $ret->{SMBD_TEST_FIFO} = "$prefix/smbd_test.fifo";
512         $ret->{SMBD_TEST_LOG} = "$prefix/smbd_test.log";
513         $ret->{SMBD_TEST_LOG_POS} = 0;
514         return $ret;
515 }
516
517 sub teardown_env($$)
518 {
519         my ($self, $envvars) = @_;
520         my $pid;
521
522         close(DATA);
523
524         if (-f "$envvars->{PIDDIR}/smbd.pid" ) {
525                 open(IN, "<$envvars->{PIDDIR}/smbd.pid") or die("unable to open smbd pid file");
526                 $pid = <IN>;
527                 close(IN);
528
529                 # Give the process 20 seconds to exit.  gcov needs
530                 # this time to write out the covarge data
531                 my $count = 0;
532                 until (kill(0, $pid) == 0) {
533                     # if no process sucessfully signalled, then we are done
534                     sleep(1);
535                     $count++;
536                     last if $count > 20;
537                 }
538                 
539                 # If it is still around, kill it
540                 if ($count > 20) {
541                     print "smbd process $pid took more than $count seconds to exit, killing\n";
542                     kill 9, $pid;
543                 }
544         }
545
546         my $failed = $? >> 8;
547
548         $self->slapd_stop($envvars) if ($self->{ldap});
549
550         print $self->getlog_env($envvars);
551
552         return $failed;
553 }
554
555 sub getlog_env($$)
556 {
557         my ($self, $envvars) = @_;
558         my $title = "SMBD LOG of: $envvars->{NETBIOSNAME}\n";
559         my $out = $title;
560
561         open(LOG, "<$envvars->{SMBD_TEST_LOG}");
562
563         seek(LOG, $envvars->{SMBD_TEST_LOG_POS}, SEEK_SET);
564         while (<LOG>) {
565                 $out .= $_;
566         }
567         $envvars->{SMBD_TEST_LOG_POS} = tell(LOG);
568         close(LOG);
569
570         return "" if $out eq $title;
571  
572         return $out;
573 }
574
575 sub check_env($$)
576 {
577         my ($self, $envvars) = @_;
578
579         return 1 if (-p $envvars->{SMBD_TEST_FIFO});
580
581         print $self->getlog_env($envvars);
582
583         return 0;
584 }
585
586 sub setup_env($$$)
587 {
588         my ($self, $envname, $path) = @_;
589
590         if ($envname eq "dc") {
591                 return $self->setup_dc("$path/dc");
592         } elsif ($envname eq "member") {
593                 if (not defined($self->{vars}->{dc})) {
594                         $self->setup_dc("$path/dc");
595                 }
596                 return $self->setup_member("$path/member", $self->{vars}->{dc});
597         } else {
598                 die("Samba4 can't provide environment '$envname'");
599         }
600 }
601
602 sub setup_member($$$$)
603 {
604         my ($self, $path, $dc_vars) = @_;
605
606         my $env = $self->provision_member($path, $dc_vars);
607
608         $self->check_or_start($env, ($ENV{SMBD_MAXTIME} or 7500));
609
610         $self->wait_for_start($env);
611
612         return $env;
613 }
614
615 sub setup_dc($$)
616 {
617         my ($self, $path) = @_;
618
619         my $env = $self->provision_dc($path);
620
621         $self->check_or_start($env, 
622                 ($ENV{SMBD_MAXTIME} or 7500));
623
624         $self->wait_for_start($env);
625
626         $self->{vars}->{dc} = $env;
627
628         return $env;
629 }
630
631 sub stop($)
632 {
633         my ($self) = @_;
634 }
635
636 1;